Bug 1276624 - Review Request: swagger-core - Java implementation of Swagger
Review Request: swagger-core - Java implementation of Swagger
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Raphael Groner
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1181081 1276555
  Show dependency treegraph
 
Reported: 2015-10-30 06:26 EDT by gil cattaneo
Modified: 2016-08-29 12:24 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-08-23 08:48:35 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
projects.rg: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description gil cattaneo 2015-10-30 06:26:03 EDT
Spec URL: https://gil.fedorapeople.org/swagger-core.spec
SRPM URL: https://gil.fedorapeople.org/swagger-core-1.5.4-1.fc22.src.rpm
Description:
The goal of Swagger is to define a standard, language-agnostic interface
to REST APIs which allows both humans and computers to discover and
understand the capabilities of the service without access to source code,
documentation, or through network traffic inspection. When properly defined
via Swagger, a consumer can understand and interact with the remote service
with a minimal amount of implementation logic. Similar to what interfaces
have done for lower level programming, Swagger removes the guesswork
in calling the service.
Fedora Account System Username: gil

Task info: http://koji.fedoraproject.org/koji/taskinfo?taskID=11637565
Comment 2 Upstream Release Monitoring 2015-11-07 07:47:30 EST
gil's scratch build of swagger-core-1.5.4-1.fc23.src.rpm for rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=11741160
Comment 3 Upstream Release Monitoring 2015-11-07 08:10:20 EST
gil's scratch build of swagger-core-1.5.4-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11741646
Comment 4 gil cattaneo 2016-01-02 05:06:29 EST
Spec URL: https://gil.fedorapeople.org/swagger-core.spec
SRPM URL: https://gil.fedorapeople.org/swagger-core-1.5.5-1.fc23.src.rpm

- update to 1.5.5
Comment 5 Upstream Release Monitoring 2016-01-02 05:31:56 EST
gil's scratch build of swagger-core-1.5.5-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=12380392
Comment 6 gil cattaneo 2016-03-03 04:38:54 EST
Spec URL: https://gil.fedorapeople.org/swagger-core.spec
SRPM URL: https://gil.fedorapeople.org/swagger-core-1.5.7-1.fc23.src.rpm

- update to 1.5.7
Comment 7 Upstream Release Monitoring 2016-03-03 04:48:37 EST
gil's scratch build of swagger-core-1.5.7-1.fc23.src.rpm for rawhide completed http://koji.fedoraproject.org/koji/taskinfo?taskID=13212072
Comment 9 Raphael Groner 2016-08-11 13:07:10 EDT
Can you take bug #1336837 for a review swap?
Comment 10 gil cattaneo 2016-08-11 13:32:03 EDT
(In reply to Raphael Groner from comment #9)
> Can you take bug #1336837 for a review swap?

Sure, reviewed and approved
Comment 11 Raphael Groner 2016-08-14 09:54:04 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed
[#] = Pass with advice/comment


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[#]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "Unknown or generated". 470 files have unknown
     license. Detailed output of licensecheck in /home/builder/fedora-
     review/1276624-swagger-core/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[#]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[#]: Final provides and requires are sane (see attachments).
[?]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in swagger-
     core-annotations , swagger-core-hibernate-validations , swagger-core-
     jaxrs , swagger-core-jersey-jaxrs , swagger-core-jersey2-jaxrs ,
     swagger-core-models , swagger-core-mule , swagger-core-project ,
     swagger-core-servlet , swagger-core-javadoc
[?]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: swagger-core-1.5.7-1.fc26.noarch.rpm
          swagger-core-annotations-1.5.7-1.fc26.noarch.rpm
          swagger-core-hibernate-validations-1.5.7-1.fc26.noarch.rpm
          swagger-core-jaxrs-1.5.7-1.fc26.noarch.rpm
          swagger-core-jersey-jaxrs-1.5.7-1.fc26.noarch.rpm
          swagger-core-jersey2-jaxrs-1.5.7-1.fc26.noarch.rpm
          swagger-core-models-1.5.7-1.fc26.noarch.rpm
          swagger-core-mule-1.5.7-1.fc26.noarch.rpm
          swagger-core-project-1.5.7-1.fc26.noarch.rpm
          swagger-core-servlet-1.5.7-1.fc26.noarch.rpm
          swagger-core-javadoc-1.5.7-1.fc26.noarch.rpm
          swagger-core-1.5.7-1.fc26.src.rpm
swagger-core-annotations.noarch: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
swagger-core-annotations.noarch: W: no-documentation
swagger-core-hibernate-validations.noarch: W: no-documentation
swagger-core-jaxrs.noarch: W: no-documentation
swagger-core-jersey-jaxrs.noarch: W: no-documentation
swagger-core-jersey2-jaxrs.noarch: W: no-documentation
swagger-core-models.noarch: W: no-documentation
swagger-core-mule.noarch: W: no-documentation
swagger-core-project.noarch: W: no-documentation
swagger-core-servlet.noarch: W: no-documentation
12 packages and 0 specfiles checked; 0 errors, 10 warnings.




Rpmlint (installed packages)
----------------------------
swagger-core-jersey-jaxrs.noarch: W: no-documentation
swagger-core-models.noarch: W: no-documentation
swagger-core-jaxrs.noarch: W: no-documentation
swagger-core-hibernate-validations.noarch: W: no-documentation
swagger-core-jersey2-jaxrs.noarch: W: no-documentation
swagger-core-mule.noarch: W: no-documentation
swagger-core-annotations.noarch: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
swagger-core-annotations.noarch: W: no-documentation
swagger-core-project.noarch: W: no-documentation
swagger-core-servlet.noarch: W: no-documentation
11 packages and 0 specfiles checked; 0 errors, 10 warnings.



Requires
--------
swagger-core-jersey-jaxrs (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(com.sun.jersey.contribs:jersey-multipart:1)
    mvn(com.sun.jersey:jersey-client:1)
    mvn(com.sun.jersey:jersey-core:1)
    mvn(com.sun.jersey:jersey-server:1)
    mvn(com.sun.jersey:jersey-servlet:1)
    mvn(io.swagger:swagger-jaxrs)

swagger-core-models (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(com.fasterxml.jackson.core:jackson-annotations)
    mvn(io.swagger:swagger-annotations)
    mvn(org.slf4j:slf4j-api)

swagger-core-jaxrs (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(com.fasterxml.jackson.dataformat:jackson-dataformat-xml)
    mvn(com.fasterxml.jackson.dataformat:jackson-dataformat-yaml)
    mvn(com.fasterxml.jackson.jaxrs:jackson-jaxrs-json-provider)
    mvn(com.google.guava:guava)
    mvn(io.swagger:swagger-core)
    mvn(javax.ws.rs:jsr311-api)
    mvn(org.reflections:reflections)

swagger-core-hibernate-validations (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(io.swagger:swagger-jaxrs)

swagger-core (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(com.fasterxml.jackson.core:jackson-annotations)
    mvn(com.fasterxml.jackson.core:jackson-databind)
    mvn(com.fasterxml.jackson.dataformat:jackson-dataformat-yaml)
    mvn(com.fasterxml.jackson.datatype:jackson-datatype-joda)
    mvn(com.google.guava:guava)
    mvn(io.swagger:swagger-models)
    mvn(javax.validation:validation-api)
    mvn(org.apache.commons:commons-lang3)
    mvn(org.slf4j:slf4j-api)

swagger-core-jersey2-jaxrs (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(io.swagger:swagger-jaxrs)
    mvn(org.glassfish.jersey.containers:jersey-container-servlet-core)
    mvn(org.glassfish.jersey.media:jersey-media-multipart)

swagger-core-mule (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(io.swagger:swagger-jaxrs)
    mvn(io.swagger:swagger-jersey-jaxrs)
    mvn(javax.ws.rs:jsr311-api)

swagger-core-annotations (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools

swagger-core-project (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(org.apache.maven.plugins:maven-compiler-plugin)
    mvn(org.apache.maven.plugins:maven-jar-plugin)
    mvn(org.apache.maven.plugins:maven-javadoc-plugin)
    mvn(org.sonatype.oss:oss-parent:pom:)

swagger-core-servlet (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(com.google.guava:guava)
    mvn(io.swagger:swagger-core)
    mvn(org.reflections:reflections)

swagger-core-javadoc (rpmlib, GLIBC filtered):
    javapackages-tools



Provides
--------
swagger-core-jersey-jaxrs:
    mvn(io.swagger:swagger-jersey-jaxrs)
    mvn(io.swagger:swagger-jersey-jaxrs:pom:)
    swagger-core-jersey-jaxrs

swagger-core-models:
    mvn(io.swagger:swagger-models)
    mvn(io.swagger:swagger-models:pom:)
    osgi(io.swagger.models)
    swagger-core-models

swagger-core-jaxrs:
    mvn(io.swagger:swagger-jaxrs)
    mvn(io.swagger:swagger-jaxrs:pom:)
    osgi(io.swagger.jaxrs)
    swagger-core-jaxrs

swagger-core-hibernate-validations:
    mvn(io.swagger:swagger-hibernate-validations)
    mvn(io.swagger:swagger-hibernate-validations:pom:)
    swagger-core-hibernate-validations

swagger-core:
    mvn(io.swagger:swagger-core)
    mvn(io.swagger:swagger-core:pom:)
    osgi(io.swagger.core)
    swagger-core

swagger-core-jersey2-jaxrs:
    mvn(io.swagger:swagger-jersey2-jaxrs)
    mvn(io.swagger:swagger-jersey2-jaxrs:pom:)
    swagger-core-jersey2-jaxrs

swagger-core-mule:
    mvn(io.swagger:swagger-mule)
    mvn(io.swagger:swagger-mule:pom:)
    swagger-core-mule

swagger-core-annotations:
    mvn(io.swagger:swagger-annotations)
    mvn(io.swagger:swagger-annotations:pom:)
    osgi(io.swagger.annotations)
    swagger-core-annotations

swagger-core-project:
    mvn(io.swagger:swagger-project:pom:)
    swagger-core-project

swagger-core-servlet:
    mvn(io.swagger:swagger-servlet)
    mvn(io.swagger:swagger-servlet:pom:)
    swagger-core-servlet

swagger-core-javadoc:
    swagger-core-javadoc



Source checksums
----------------
https://github.com/swagger-api/swagger-core/archive/v1.5.7/swagger-core-1.5.7.tar.gz :
  CHECKSUM(SHA256) this package     : ed84b5034862e9f62b691350f6ca643467b25b472e519791d9030bba22b6a533
  CHECKSUM(SHA256) upstream package : ed84b5034862e9f62b691350f6ca643467b25b472e519791d9030bba22b6a533


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -v -m fedora-rawhide-x86_64 -b 1276624
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 12 Raphael Groner 2016-08-14 10:17:48 EDT
APPROVED

Some advice/comments:

- Most of the java source files are without any license header to let our licensecheck script fail. Please poke upstream and ask to add everywhere the Apache header.

- My recommendation goes to use the same names for subpackages as the included pom files are named. E.g.:
  %package jersey-jaxrs (better: %package -n swagger-jersey-jaxrs)
  result: swagger-core-jersey-jaxrs (better: swagger-jersey-jaxrs)
  /usr/share/maven-poms/swagger-core/swagger-jersey-jaxrs.pom
  swagger-core/modules/swagger-jersey-jaxrs/pom.xml

  See https://fedoraproject.org/wiki/Packaging:Java#Filenames

- There's a new version 1.5.9 at upstream.
Comment 13 Raphael Groner 2016-08-14 10:19:30 EDT
#java.lang.AssertionError: expected [4] but found [2]
rm -r modules/swagger-core/src/test/java/io/swagger/ModelConverterTest.java
#java.lang.AssertionError: Serialized object:
#{"in":"query","required":false,"type":"integer","default":1234,"format":"1nt64"}
#does not equal to expected serialized string:
#{"in":"query","required":false,"type":"integer","default":1234,"format":"1nt64"}
rm -r modules/swagger-core/src/test/java/io/swagger/parameter/ParameterSerializationTest.java

Did you report to upstream?
Comment 14 Raphael Groner 2016-08-14 10:26:56 EDT
# org.powermock:powermock-module-testng:1.6.4
%pom_remove_dep org.powermock:powermock-module-testng modules/swagger-models
rm modules/swagger-models/src/test/java/io/swagger/models/ArrayModelTest.java \
 modules/swagger-models/src/test/java/io/swagger/models/ModelImplTest.java

Available in Rawhide and F25:

* Wed Jun 01 2016 Michael Simacek <msimacek@redhat.com> - 1.6.5-2
- Enable TestNG module
Comment 15 gil cattaneo 2016-08-14 11:11:40 EDT
(In reply to Raphael Groner from comment #14)
> # org.powermock:powermock-module-testng:1.6.4
> %pom_remove_dep org.powermock:powermock-module-testng modules/swagger-models
> rm
> modules/swagger-models/src/test/java/io/swagger/models/ArrayModelTest.java \
>  modules/swagger-models/src/test/java/io/swagger/models/ModelImplTest.java
> 
> Available in Rawhide and F25:
> 
> * Wed Jun 01 2016 Michael Simacek <msimacek@redhat.com> - 1.6.5-2
> - Enable TestNG module

NO compatible with the required version

(In reply to Raphael Groner from comment #13)
> #java.lang.AssertionError: expected [4] but found [2]
> rm -r modules/swagger-core/src/test/java/io/swagger/ModelConverterTest.java
> #java.lang.AssertionError: Serialized object:
> #{"in":"query","required":false,"type":"integer","default":1234,"format":
> "1nt64"}
> #does not equal to expected serialized string:
> #{"in":"query","required":false,"type":"integer","default":1234,"format":
> "1nt64"}
> rm -r
> modules/swagger-core/src/test/java/io/swagger/parameter/
> ParameterSerializationTest.java
> 
> Did you report to upstream?
No the problem happen because of jackson-dataformat-xml and woodstox libraries (woodstox-core, stax2-api). i prefer remove these tests
(In reply to Raphael Groner from comment #12)
> APPROVED
> 
> Some advice/comments:
> 
> - Most of the java source files are without any license header to let our
> licensecheck script fail. Please poke upstream and ask to add everywhere the
> Apache header.

Reported @ https://github.com/swagger-api/swagger-core/issues/1882

> - My recommendation goes to use the same names for subpackages as the
> included pom files are named. E.g.:
>   %package jersey-jaxrs (better: %package -n swagger-jersey-jaxrs)
>   result: swagger-core-jersey-jaxrs (better: swagger-jersey-jaxrs)
>   /usr/share/maven-poms/swagger-core/swagger-jersey-jaxrs.pom
>   swagger-core/modules/swagger-jersey-jaxrs/pom.xml
> 
>   See https://fedoraproject.org/wiki/Packaging:Java#Filenames
i prefer in this way, and guideline do not specific the way of naming a (sub)package(s)
> - There's a new version 1.5.9 at upstream.

for now i use/import this release

Spec URL: https://gil.fedorapeople.org/swagger-core.spec
SRPM URL: https://gil.fedorapeople.org/swagger-core-1.5.7-2.fc24.src.rpm
Comment 17 Gwyn Ciesla 2016-08-15 10:59:06 EDT
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/swagger-core
Comment 18 Fedora Update System 2016-08-15 13:43:59 EDT
swagger-core-1.5.7-2.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-2ad426c4c6
Comment 19 Fedora Update System 2016-08-15 13:49:30 EDT
swagger-core-1.5.7-2.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-ef5afb7c2d
Comment 20 Fedora Update System 2016-08-16 01:54:59 EDT
swagger-core-1.5.7-2.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-ef5afb7c2d
Comment 21 Fedora Update System 2016-08-16 12:26:18 EDT
swagger-core-1.5.7-2.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-2ad426c4c6
Comment 22 Fedora Update System 2016-08-23 08:48:33 EDT
swagger-core-1.5.7-2.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.
Comment 23 Fedora Update System 2016-08-27 06:31:01 EDT
swagger-core-1.5.7-2.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.